classification
Title: IDLE: change Shell window title
Type: enhancement Stage: resolved
Components: IDLE Versions: Python 3.10, Python 3.9, Python 3.8
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: terry.reedy Nosy List: cheryl.sabella, epaine, miss-islington, terry.reedy
Priority: normal Keywords: patch

Created on 2020-09-13 04:00 by terry.reedy, last changed 2020-09-24 20:09 by terry.reedy. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 22399 merged terry.reedy, 2020-09-24 18:37
PR 22400 merged miss-islington, 2020-09-24 19:30
PR 22401 merged miss-islington, 2020-09-24 19:31
Messages (5)
msg376819 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-09-13 04:00
The IDLE Shell window title is set with pyshell line 836
    shell_title = "Python " + python_version() + " Shell"
The python_version() part was added in March 2013 by the first patch for issue 17390: https://hg.python.org/cpython/rev/74d9a9507019.

In issue 41765, Mark Summerfield suggested in a side-comment that the title should be 'IDLE'.

E. Paine agreed that it should be changed, suggesting that it contributes to the fact that "there are lots people when first starting who think the IDLE shell *is the* Python shell".  I have noticed this fact on Stackoverflow, where about half the questions tagged 'python-idle' have nothing to do with IDLE.  (I regularly remove such mistaken tags.)  I have wondered why and how to better counter this.  For one thing, it results in users blaming IDLE for Python behavior, such as not running buggy code.  I never noticed before that IDLE promotes the confusion a bit in the shell title.

Issues such as #37903 (move prompt to shell sidebar, which I am planning to review soon) and #37892 (separate input area) will differentiate the IDLE Shell from the standard REPL even more.

Paine suggested 'IDLE <version> Shell'.  I don't want to suggest that IDLE is independently versioned, and prefer 'IDLE Shell (<version>)'.  The parenthesized version is used for editor windows (and was also added by #17390).  On Windows, mousing over a taskbar icon initially shows about 10-14 variable-width letters of the title.  Is 'Shell' or '3.x.y' more important to be ensured of visibility?

Other suggestions and comments?

[If IDLE becomes a tabbed-window application, the window title would be 'IDLE (version)' and the shell would be on a 'Shell' tab.]
msg377455 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-09-24 19:30
New changeset 05cc881cbcf5d73a312568c78c7149eae3195072 by Terry Jan Reedy in branch 'master':
bpo-41775: Make 'IDLE Shell' the shell title  (#22399)
https://github.com/python/cpython/commit/05cc881cbcf5d73a312568c78c7149eae3195072
msg377457 - (view) Author: miss-islington (miss-islington) Date: 2020-09-24 20:07
New changeset 4080f12ccccb17cee36732758912dc4346ec9361 by Miss Islington (bot) in branch '3.9':
bpo-41775: Make 'IDLE Shell' the shell title  (GH-22399)
https://github.com/python/cpython/commit/4080f12ccccb17cee36732758912dc4346ec9361
msg377458 - (view) Author: miss-islington (miss-islington) Date: 2020-09-24 20:08
New changeset 18e59f587b86297d4fc99765be10d92a717d4775 by Miss Islington (bot) in branch '3.8':
bpo-41775: Make 'IDLE Shell' the shell title  (GH-22399)
https://github.com/python/cpython/commit/18e59f587b86297d4fc99765be10d92a717d4775
msg377459 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-09-24 20:09
In the last few months, there has been an increase in bpo issues mis-tagged IDLE.  Today's example: #41774
History
Date User Action Args
2020-09-24 20:09:15terry.reedysetstatus: open -> closed
resolution: fixed
messages: + msg377459

stage: patch review -> resolved
2020-09-24 20:08:09miss-islingtonsetmessages: + msg377458
2020-09-24 20:07:56miss-islingtonsetmessages: + msg377457
2020-09-24 19:31:03miss-islingtonsetpull_requests: + pull_request21441
2020-09-24 19:30:50miss-islingtonsetnosy: + miss-islington
pull_requests: + pull_request21440
2020-09-24 19:30:31terry.reedysetmessages: + msg377455
2020-09-24 18:37:33terry.reedysetkeywords: + patch
stage: needs patch -> patch review
pull_requests: + pull_request21439
2020-09-19 12:36:33taleinatsetnosy: - taleinat
2020-09-13 04:00:10terry.reedycreate